unit uDataView;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, AdvObj, BaseGrid, AdvGrid, DB, DBClient, uCDSThread,
  syncobjs, uEmployeeClass, generics.collections;

type
  TfrmData = class(TForm)
    gridAnimals: TAdvStringGrid;
    gridEmployee: TAdvStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    gridCustomer: TAdvStringGrid;
    cdsAnimals: TClientDataSet;
    cdsCustomer: TClientDataSet;
    cdsEmployee: TClientDataSet;
    procedure gridEmployeeDblClickCell(Sender: TObject; ARow, ACol: Integer);
  private
    animalThread :   TCdsThread;
    employeeThread : TEmployeeThread;
    CustomerThread : TCdsThread;
    usingThreads : Boolean;

    EmployeeList : TOBjectList<TEmployee>;
    procedure getAllData;
    procedure getAnimals;
    procedure getCustomer;
    procedure getEmployee;
    procedure animalDone(sender: TObject);
    procedure CustomerDone(sender: TObject);
    procedure EmployeeDone(sender: TObject);

    { Private declarations }
  public
    { Public declarations }
    Class Procedure OpenDataView(useThreads : Boolean);
  end;

var
critSec : TCriticalSection;

implementation



{$R *.dfm}

{ TfrmData }

class procedure TfrmData.OpenDataView(useThreads : Boolean);
var
  frmData: TfrmData;
begin
  frmData := TfrmData.Create(nil);
  try
    frmData.EmployeeList := TObjectList<TEmployee>.create(true);
    frmData.usingThreads := useThreads;
    frmData.GetAllData;
    frmData.ShowModal;
  finally
    frmData.Release;
  end;
end;

procedure TfrmData.getAllData;
begin
  getAnimals;
  getCustomer;
  getEmployee;
  if not UsingThreads then
  begin
    gridAnimals.Enabled := true;
    gridEmployee.Enabled := true;
    gridCustomer.Enabled := true;
  end;
end;


procedure TfrmData.animalDone(sender : TObject);
begin
  gridAnimals.Enabled := true;
  //animalThread.Free;
end;

procedure TfrmData.CustomerDone(sender : TObject);
begin
  gridCustomer.Enabled := true;
//  customerThread.Free;
end;

procedure TfrmData.EmployeeDone(sender : TObject);
begin
  gridEmployee.Enabled := true;
//  employeeThread.Free;
end;


procedure TfrmData.getAnimals;
var
 I, idx : integer;
begin
  if not usingThreads then
  begin
    cdsAnimals.LoadFromFile('c:\Program Files\Common Files\CodeGear Shared\Data\animals.xml');
    cdsAnimals.Open;
    gridAnimals.RowCount := cdsAnimals.RecordCount +1;
    gridAnimals.ColCount := cdsAnimals.FieldCount;
    idx := 1;
    while not cdsAnimals.eof do
    begin

      for I := 0 to gridAnimals.ColCount -1 do
      begin

        gridAnimals.Cells[i, idx] := cdsAnimals.Fields[i].AsString;
      end;
      cdsAnimals.Next;
      inc(idx);
      sleep(17);
    end;
  end
  else
  begin

    animalThread := TCdsThread.Create(true); //TSimpleThread.Create(true);

    animalThread.cds := cdsAnimals;
    animalThread.cdsFilename := 'c:\Program Files\Common Files\CodeGear Shared\Data\animals.xml';
    animalThread.grid := gridAnimals;
    animalThread.OnTerminate := animalDone;
    animalThread.FreeOnTerminate := true;
    animalThread.Start;
  end;
end;

procedure TfrmData.getCustomer;
var
 I, idx : integer;
begin
    if not usingThreads then
    begin
    cdsCustomer.LoadFromFile('c:\Program Files\Common Files\CodeGear Shared\Data\Customer.xml');
    cdsCustomer.Open;
    gridCustomer.RowCount := cdsCustomer.RecordCount +1;
    gridCustomer.ColCount := cdsCustomer.FieldCount;
    idx := 1;
    while not cdsCustomer.eof do
    begin

      for I := 0 to gridCustomer.ColCount -1 do
      begin

        gridCustomer.Cells[i, idx] := cdsCustomer.Fields[i].AsString;
      end;
      cdsCustomer.Next;
      inc(idx);
      sleep(17);
    end;
    end
    else
    begin
      customerThread := TCdsThread.Create(true);
      customerThread.cds := cdsCustomer;
      customerThread.cdsFilename := 'c:\Program Files\Common Files\CodeGear Shared\Data\Customer.xml';
      customerThread.grid := gridCustomer;
      customerThread.OnTerminate := CustomerDone;
      customerThread.FreeOnTerminate := true;
      customerThread.Start;

    end;
end;

procedure TfrmData.getEmployee;
var
 I, idx : integer;
begin
    if not usingThreads then
    begin
    cdsEmployee.LoadFromFile('c:\Program Files\Common Files\CodeGear Shared\Data\Employee.xml');
    cdsEmployee.Open;
    gridEmployee.RowCount := cdsEmployee.RecordCount +1;
    gridEmployee.ColCount := cdsEmployee.FieldCount;
    idx := 1;
    while not cdsEmployee.eof do
    begin

      for I := 0 to gridEmployee.ColCount -1 do
      begin

        gridEmployee.Cells[i, idx] := cdsEmployee.Fields[i].AsString;
      end;
      cdsEmployee.Next;
      inc(idx);
      sleep(17);
    end;
    end
    else
    begin
      employeeThread := TEmployeeThread.Create(true);
      employeeThread.cds := cdsemployee;
      employeeThread.cdsFilename := 'c:\Program Files\Common Files\CodeGear Shared\Data\Employee.xml';
      employeeThread.grid := gridEmployee;
      employeeThread.EmployeeList := self.EmployeeList;
      employeeThread.OnTerminate := EmployeeDone;
      employeeThread.FreeOnTerminate := true;
      employeeThread.Start;
    end;

end;


procedure TfrmData.gridEmployeeDblClickCell(Sender: TObject; ARow,
  ACol: Integer);
begin
    if aRow > 0 then
    begin
      if gridEmployee.Objects[0, aRow] is TEmployee then
      begin
        ShowMessage(TEmployee(gridEmployee.Objects[0, aRow]).FullName);
      end;
    end;
end;

initialization
  critSec := TCriticalSection.Create;


Finalization
  critSec.Destroy;

end.
