unit uEmployeeClass;

interface

uses
  SysUtils, db, MSAccess;

type
  TEmployee = class(Tobject)
    private
    FLastname: String;
    FHireDate: TDateTime;
    FEmployeeNumber: integer;
    FSalary: Double;
    FPhoneExtenstion: string;
    FFirstName: string;
    function getHireDateAsString: string;
    procedure SetEmployeeNumber(const Value: integer);
    procedure SetFirstName(const Value: string);
    procedure SetHireDate(const Value: TDateTime);
    procedure SetLastname(const Value: String);
    procedure SetPhoneExtenstion(const Value: string);
    procedure SetSalary(const Value: Double);
    function getFullName: string;
    public
      property EmployeeNumber : integer read FEmployeeNumber write SetEmployeeNumber;
      property Lastname : String read FLastname write SetLastname;
      property FirstName : string read FFirstName write SetFirstName;
      property FullName : string read getFullName;
      property PhoneExtenstion : string read FPhoneExtenstion write SetPhoneExtenstion;
      property HireDate : TDateTime read FHireDate write SetHireDate;

      property HireDateAsString : string read getHireDateAsString;
      property Salary : Double read FSalary write SetSalary;
      procedure LoadFromDataset(aDataSet : TDataset);
      Function SaveToDatabase(aConnection : TMSConnection) : integer;
  end;

implementation

{ TEmployee }

function TEmployee.getFullName: string;
begin
  result := self.FFirstName + ' ' + self.FLastname;
end;

function TEmployee.getHireDateAsString: string;
begin
  if self.fHireDate < 1 then
    result := ''
  else
    result := DateTimeToStr(Trunc(self.FHireDate));
end;

procedure TEmployee.LoadFromDataset(aDataSet: TDataset);
begin
  self.FLastname        := aDataset.FieldByName('LASTNAME').AsString;
  self.FFirstName       := aDataset.FieldByName('FIRSTNAME').AsString;
  self.FHireDate        := aDataset.FieldByName('HIREDATE').AsDateTime;
  self.FEmployeeNumber  := aDataset.FieldByName('EMPNO').AsInteger;
  self.FSalary          := aDataset.FieldByName('SALARY').AsFloat;
  self.FPhoneExtenstion := aDataset.FieldByName('PHONEEXT').AsString;
end;

function TEmployee.SaveToDatabase(aConnection: TMSConnection): integer;
var
  aQry : TMSQuery;
begin
  aQry := TMSQuery.Create(nil);
  aQry.Connection := aConnection;
  try
    aQry.SQL.Add('SELECT....');
  finally
    aQry.Free;
  end;
end;

procedure TEmployee.SetEmployeeNumber(const Value: integer);
begin
  FEmployeeNumber := Value;
end;

procedure TEmployee.SetFirstName(const Value: string);
begin
  FFirstName := Value;
end;

procedure TEmployee.SetHireDate(const Value: TDateTime);
begin
  FHireDate := Value;
end;

procedure TEmployee.SetLastname(const Value: String);
begin
  FLastname := Value;
end;

procedure TEmployee.SetPhoneExtenstion(const Value: string);
begin
  FPhoneExtenstion := Value;
end;

procedure TEmployee.SetSalary(const Value: Double);
begin
  FSalary := Value;
end;

end.
